#ifndef FIXEDDIALOG_H
#define FIXEDDIALOG_H

#include <qlineedit.h>
#include <qdialog.h>

class FixedDialog:public QDialog {
	Q_OBJECT
public:
	FixedDialog(QWidget *parent, QString name);
	double getLength(void);
	double getAngle(void);
	void setLength(double);
	void setAngle(double);

	public slots:
	  void setDefaults();

private:
	QLineEdit *tf_title;
	QLineEdit *tf_id;
};

#endif
