#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>

#include <qstringlist.h>
#include <qstring.h>
#include <qtextstream.h>

#include "netaccess.h"

QStringList NetAccess::getChoices(QString server, QString key, QString value,
				  bool exact) {
  QStringList results;

  if (key == "Formula") {
    // put atoms in proper order
    value = Rearrange(value);
  }

  QString cmd;

  cmd.append("curl -s \"http://");
  cmd.append(server);
  cmd.append("/cgi-bin/xdcdb?key=");
  cmd.append(key);
  cmd.append("&value=");
  cmd.append(value);
  cmd.append("&em=");
  if (exact)
    cmd.append("true");
  else
    cmd.append("false");
  cmd.append("\"");
  
  //cout << cmd << endl;

  FILE *test1;
  char *spam;
  test1 = popen(cmd.ascii(), "r");
  spam = (char*)malloc(sizeof(char) * 65536);
  fread(spam, 1, 65535, test1);
  QString testq = spam;

  //cout << testq << endl;

  QTextStream in1(&testq, IO_ReadOnly);

  bool saveflag = false;
  QString tmpl;
  do {
    tmpl = in1.readLine();
    if (tmpl == "XXX") { saveflag = true; continue; }
    if (tmpl == "YYY") { saveflag = false; continue; }
    if (saveflag) results.append(tmpl);
  } while (!in1.atEnd());

  pclose(test1);
  free(spam);

  return results;  // what a program should always do!
}

QString NetAccess::getFile(QString server, QString fn) {
  QString wholefile;

  QString cmd;

  cmd.append("curl -s \"http://");
  cmd.append(server);
  cmd.append("/cgi-bin/getfile?name=");
  cmd.append(fn);
  cmd.append("\"");
  
  //cout << cmd << endl;

  FILE *test1;
  char *spam;
  test1 = popen(cmd.ascii(), "r");
  spam = (char*)malloc(sizeof(char) * 65536);
  fread(spam, 1, 65535, test1);
  wholefile = spam;

  return wholefile;
}

QString NetAccess::Rearrange(QString key) {
  QString key1, subkey, subnum;
  int count, sublen, cc;
  bool addflag;
  
  QStringList allatoms;

  do {
    cout << key << endl;
    // parse out element
    subkey = "";
    addflag = false;
    subkey.append(key[0]);
    for (cc = 1; cc < key.length(); cc++) {
      if (key[cc].category() == QChar::Letter_Uppercase) {
	allatoms.append(subkey);
	key.remove(0, cc);
	addflag = true;
	break;
      } else {
	subkey.append(key[cc]);
      }
    }
    if (addflag == false) {
      allatoms.append(subkey);
      key.remove(0, cc);
    }
  } while (key.length() > 0);

  cout << allatoms.count() << endl;
  
  QString sym, n1;
  allatoms.sort();
  if (allatoms.count() > 0) {
    for (QStringList::Iterator ir = allatoms.begin(); 
	 ir != allatoms.end(); ++ir) {
      key1.append(*ir);
    }
  }

  return key1;
}

